#
# spec file for package htdig (Version 3.1.6)
#
# Copyright (c) 2005 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  apache-devel-packages autoconf automake gcc-c++ gpp libgpp libstdc++ libstdc++-devel mm
# usedforbuild    aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch permissions popt ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel apache apache-devel autoconf automake binutils cracklib expat gcc gcc-c++ gdbm gettext libstdc++-devel libtool mm mod_ssl perl rpm

Name:         htdig
%define apache_serverroot %(apxs -q datadir 2>/dev/null || apxs -q PREFIX)
URL:          http://www.htdig.org
License:      GPL
Group:        Productivity/Networking/Web/Utilities
Autoreqprov:  on
Version:      3.1.6
Release:      407
Summary:      WWW index and search system
Source:       htdig-%{version}.tar.bz2
Patch:        htdig-%{version}.dif 
Patch1:       64bit.patch
Patch2:       x86_64_spinlocks.patch
Patch3:       htsearch_64.patch
Patch4:       htdig-htnotify-memory-fix.diff
Patch5:       htdig-3.1.X-file_url.diff
Patch6:       htdig-codecleanup.diff
Patch7:       htdig-configure.diff
Patch9:       htdig-3.1.6-cross-site-CAN-2005-0085.patch
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
The ht://Dig system is a complete world wide web index and search
system for a small domain or intranet. This system is not meant to
replace the need for powerful internet-wide search systems like Lycos,
Infoseek, Webcrawler, or AltaVista. Instead it is meant to cover the
search needs of a single company, campus, or even a particular sub
section of a web site.

Unlike some WAIS-based or web-server based search engines, ht://Dig can
span several web servers at a site. The type of these web servers does
not matter as long as they understand the HTTP 1.0 protocol.



Authors:
--------
    Andrew Scherpbier <andrew@contigo.com>

%prep
%setup -q
%patch
%patch1
%patch2
%patch3
%patch4 -p 0
%patch5
%patch6
%patch7
%patch9 -p 1

%build
%{?suse_update_config:%{suse_update_config -f db/dist}}
#(cd db/dist; autoconf)
rm -f acconfig.h db/dist/acconfig.h aclocal.m4 configure db/dist/configure
autoreconf --force --install
# --with-config-dir=%{_sysconfdir}/htdig \
#   --with-config-dir=%{apache_serverroot}/htdig/conf
export CC=gcc CXX=g++
export CXXFLAGS="$RPM_OPT_FLAGS -W -Wall"
export CFLAGS="$RPM_OPT_FLAGS -W -Wall -Wstrict-prototypes -Wno-unused-parameter"
export CPPFLAGS="-D_GNU_SOURCE"
./configure --prefix=/usr \
   --with-config-dir=%{_sysconfdir}/htdig \
   --with-common-dir=%{apache_serverroot}/htdig/common \
   --with-database-dir=/var/lib/htdig/db \
   --with-cgi-bin-dir=%{apache_serverroot}/cgi-bin \
   --with-image-dir=%{apache_serverroot}/htdig/images \
   --with-image-url-prefix=images \
   --with-search-dir=%{apache_serverroot}/htdig
make depend
make

%post
if [ "$1" -gt 1 ]; then
  oldconf=%{apache_serverroot}/htdig/conf
  newconf=%{_sysconfdir}/htdig
  # if [ -f $oldconf -a ! $newconf ]; then
  #   mkdir ${newconf%/*}
  #   cp -v $oldconf $newconf.rpmorig
  # # does not work as expected
  #   cp -v $oldconf $newconf
  # fi
  function update_info() {
    test -z "${UPDATE_INFO}" || return
    echo "Copying %{name} config files to new location %{_sysconfdir}/%{name}/ :"
    UPDATE_INFO="yes"
  }
  for fn in htdig.conf; do
    if [ -f $oldconf/${fn} ]; then
      update_info
      echo ${fn}
      test -f $newconf/${fn} \
        && ( diff $oldconf/${fn} $newconf/${fn} >/dev/null || old $newconf/${fn} )
      cp -a $oldconf/${fn} $newconf/${fn}
      mkdir -p var/adm/notify/messages
      cat << EOF > var/adm/notify/messages/%{name}-notify
Hello,  (deutsche Version weiter unten)
 
the configuration file was moved to ${newconf}.
 
 
Hallo,
 
die Konfigurationdatei wurde nach ${newconf} verschoben.
EOF
    fi
  done
  test -z "${UPDATE_INFO}" || echo "...done"
fi

%install
find . -name \*.orig | xargs rm  -f
make INSTALL_ROOT=$RPM_BUILD_ROOT install

%files
%doc COPYING ChangeLog README README.SuSE contrib htdoc
%config(noreplace) %{_sysconfdir}/htdig
%dir %{apache_serverroot}/htdig
%{apache_serverroot}/htdig/search.html
%{apache_serverroot}/htdig/common
%{apache_serverroot}/htdig/images
%dir /var/lib/htdig
/var/lib/htdig/db
%{apache_serverroot}/cgi-bin/htsearch
/usr/bin/rundig
/usr/bin/htfuzzy
/usr/bin/htmerge
/usr/bin/htnotify
/usr/bin/htdig
/usr/bin/htdump
/usr/bin/htload
# /usr/local/httpsd/cgi-bin/htsearch
# /usr/local/httpsd/htdocs/htdig

%changelog -n htdig
* Thu Jan 27 2005 - ke@suse.de
- Fix a cross site scripting flaw as found by Michael Krax; apply the
  patch proposed by Phil Knirsch (modified for version 3.1.6);
  CAN-2005-0085 [# 50238].
* Thu Jul 17 2003 - pthomas@suse.de
- Add patch to enable passing file::/ URLs.
- Adapt configure.in of htdig and included libdb to autoconf 2.5X.
- Compile with full warnings enabled.
- Fix nearly all compiler warnings.
* Wed Jun 11 2003 - kukuk@suse.de
- Add missing directories to filelist
* Wed Jun 11 2003 - ke@suse.de
- For updating the config file use %%post instead of %%pre.
* Tue Jun 10 2003 - ke@suse.de
- Move config file to /etc/htdig/htdig.conf; reported by Michal Svec
  [# 27080].
- Save old config file as /etc/htdig/htdig.conf.rpmorig.
* Wed May 28 2003 - ke@suse.de
- Fix memory problem with htnotify [# 26913]; reported by Daniele
  Frijia.  Apply patch provided by Martin Kraemer;
  http://sourceforge.net/tracker/index.php?func=detail&aid=593091&group_id=4593&atid=304593
* Tue Apr 29 2003 - freitag@suse.de
- fixed a 64-bit problem with htsearch, see Bug #26358,
  results in diff htsearch_64.patch
* Wed Apr 16 2003 - coolo@suse.de
- use BuildRoot
* Tue Feb 11 2003 - freitag@suse.de
- fixed location of the images of htdig in the conf file. They are
  now relative to the document root (Bug #15500)
* Wed Nov 06 2002 - freitag@suse.de
- fixed broken patches
* Tue Nov 05 2002 - freitag@suse.de
- fixed the README file ( Bug #20062)
* Tue Sep 17 2002 - ro@suse.de
- removed bogus self-provides
* Mon Sep 09 2002 - uli@suse.de
- increased DB_FILE_ID_LEN in DB2 to 24 to fit 64 bit __ino_t type
  on x86-64, ia64, s390x and ppc64
- enabled x86 spinlock implementation on x86-64
* Fri Aug 02 2002 - ro@suse.de
- adapt server-root
* Wed Jun 19 2002 - freitag@suse.de
- update to version 3.1.6, which
  * fixes some security wholes that were fixed by patches formerly
  * fixes many small bugs
  * brings tools to generate ascii databases
  * adds a bunch of new keywords
  The SuSE package now installs to other pathes, please read README.SuSE
  for further information.
* Tue Feb 19 2002 - freitag@suse.de
- signed config files as %%conf in the spec file and fixed the
  filelist (Bug #12326)
* Wed Jan 23 2002 - schwab@suse.de
- Fix for gcc3.
* Thu Aug 16 2001 - utuerk@suse.de
- dropped 'out-of-date' notify [#6139]
- dropped unneeded dochost templates, left the originals [#9715]
* Tue May 08 2001 - mfabian@suse.de
- bzip2 sources
* Fri Feb 23 2001 - ro@suse.de
- changed neededforbuild <apache> to <apache apache-devel>
* Wed Jan 31 2001 - freitag@suse.de
- fixed a typo in html-files
* Sun Jan 14 2001 - kukuk@suse.de
- Add group tag
* Fri Sep 08 2000 - schwab@suse.de
- Add ia64 support in db.
* Thu Apr 13 2000 - ro@suse.de
- added mm to neededforbuild
* Wed Mar 08 2000 - freitag@suse.de
- fixing wrong links to images on localhost
* Wed Mar 08 2000 - freitag@suse.de
- fixing again some links, clearifying change losses
* Mon Mar 06 2000 - freitag@suse.de
- removed entries from /usr/local/httpsd
* Sat Mar 04 2000 - freitag@suse.de
- fixed layout on search pages
* Tue Feb 29 2000 - freitag@suse.de
- update to version 3.1.5 - Security fixes.
* Mon Feb 21 2000 - freitag@suse.de
- patches for using with kdevellop added
* Thu Feb 10 2000 - freitag@suse.de
- new version 3.1.4
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Jul 12 1999 - ray@suse.de
- update to 3.1.2
* Wed Mar 17 1999 - ro@suse.de
- diff cleanup
* Thu Jan 28 1999 - ray@suse.de
- fix S.u.S.E -> SuSE ;)
* Sat Jan 16 1999 - ray@suse.de
- fix /usr/local/bin/perl require
* Mon Dec 07 1998 - ray@suse.de
- update docu
* Thu Nov 05 1998 - ray@suse.de
- update to 3.1.0b2
* Mon Sep 14 1998 - ro@suse.de
- update to 3.1.0b1
- cleanup: use original source and extra tar for suse-gif
* Tue Jun 16 1998 - bs@suse.de
- fixed neededforbuild in spec file
* Wed May 13 1998 - ray@suse.de
- fix for startpage (search.html)
* Mon Apr 20 1998 - ro@suse.de
- fixed dependency for /usr/local/bin/perl
* Mon Mar 23 1998 - ray@suse.de
- insert whole htdoc and contrib
* Wed Mar 11 1998 - ray@suse.de
- fix (send mail to root)
* Tue Mar 03 1998 - ray@suse.de
- new packages
- htdig  Version 3.0.8b2
